# coding: utf-8

"""
    Amber API Server

    Boon Logic Amber API server

    OpenAPI spec version: 2.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PostLearningRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'state': 'str',
        'training': 'TrainingConfig',
        'autotuning': 'AutotuneConfig'
    }

    attribute_map = {
        'state': 'state',
        'training': 'training',
        'autotuning': 'autotuning'
    }

    def __init__(self, state=None, training=None, autotuning=None):
        """PostLearningRequest - a model defined in Swagger"""
        self._state = None
        self._training = None
        self._autotuning = None
        self.discriminator = None
        self.state = state
        self.training = training
        if autotuning is not None:
            self.autotuning = autotuning

    @property
    def state(self):
        """Gets the state of this PostLearningRequest.

        Desired learning state.

        :return: The state of this PostLearningRequest.
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this PostLearningRequest.

        Desired learning state.

        :param state: The state of this PostLearningRequest.
        :type: str
        """
        if state is None:
            raise ValueError("Invalid value for `state`, must not be `None`")
        allowed_values = ["Buffering", "Learning"]
        if state not in allowed_values:
            raise ValueError(
                "Invalid value for `state` ({0}), must be one of {1}"
                .format(state, allowed_values)
            )

        self._state = state

    @property
    def training(self):
        """Gets the training of this PostLearningRequest.


        :return: The training of this PostLearningRequest.
        :rtype: TrainingConfig
        """
        return self._training

    @training.setter
    def training(self, training):
        """Sets the training of this PostLearningRequest.


        :param training: The training of this PostLearningRequest.
        :type: TrainingConfig
        """
        if training is None:
            raise ValueError("Invalid value for `training`, must not be `None`")

        self._training = training

    @property
    def autotuning(self):
        """Gets the autotuning of this PostLearningRequest.


        :return: The autotuning of this PostLearningRequest.
        :rtype: AutotuneConfig
        """
        return self._autotuning

    @autotuning.setter
    def autotuning(self, autotuning):
        """Sets the autotuning of this PostLearningRequest.


        :param autotuning: The autotuning of this PostLearningRequest.
        :type: AutotuneConfig
        """

        self._autotuning = autotuning

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PostLearningRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PostLearningRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
